**************************************************************************
*                                                                        *
*  Descripcin: Definicion de algunas interfaces SHELL                   *
*                                                                        *
*  Autor: Jos F. Gimnez (JFG) - jfgimenez@wanadoo.es                   *
*                                 tecnico.sireinsa@ctv.es                *
*  Fecha: 13-3-2001                                                      *
*                                                                        *
*  Nota: Estas interfaces no estan completas, son solamente una parte.   *
*        Pero son el comienzo...                                         *
*                                                                        *
*  Remark: This interfaces are not complete, but this is the beginning.  *
*                                                                        *
**************************************************************************

#include "FiveWin.ch"
#include "ShlObj.ch"

//--------------------------------------------------------------------------

BEGIN_INTERFACE IShellLink IID {000214ee-0000-0000-c000-000000000046}

   ICREATE CLSID_ShellLink
   IMETHOD GetPath( @cFile, @nMaxPath, @pfd, nFlags )
   IMETHOD GetIDList( @ppidl )
   IMETHOD SetIDList( pidl )
   IMETHOD GetDescription( @cName, @pnMaxName )
   IMETHOD SetDescription( cName )
   IMETHOD GetWorkingDirectory( @cDir, @pnMaxPath )
   IMETHOD SetWorkingDirectory( cDir )
   IMETHOD GetArguments( @cArgs, @pnMaxPath )
   IMETHOD SetArguments( cArgs )
   IMETHOD GetHotkey( @pnHotkey )
   IMETHOD SetHotkey( nHotkey )
   IMETHOD GetShowCmd( @pnShowCmd )
   IMETHOD SetShowCmd( nShowCmd )
   IMETHOD GetIconLocation( @cIconPath, @pnIconPath, @pnIcon )
   IMETHOD SetIconLocation( cIconPath, nIcon )
   IMETHOD SetRelativePath( cPathRel, nReserved )
   IMETHOD Resolve( hwnd, nFlags )
   IMETHOD SetPath( cFile )

END_INTERFACE

//--------------------------------------------------------------------------

BEGIN_INTERFACE IPersist IID {0000010c-0000-0000-C000-000000000046}

   IMETHOD GetClassID( pClassID )

END_INTERFACE

//--------------------------------------------------------------------------

BEGIN_INTERFACE IPersistFile IID {0000010b-0000-0000-c000-000000000046} ;
           FROM IPersist

   IMETHOD IsDirty()
   IMETHOD Load( cFileName, nMode )
   IMETHOD Save( cFileName, lRemember )
   IMETHOD SaveCompleted( cFileName )
   IMETHOD GetCurFile( @pcFileName )

END_INTERFACE

//--------------------------------------------------------------------------

FUNCTION GetDesktopDir()

   LOCAL cPath := SPACE(255), nHandle, nLen := 255, nType := 1

   #define  HKEY_CURRENT_USER       2147483649

   if RegOpenKeyEx( HKEY_CURRENT_USER, ;
         "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", ;
         0, 63, @nHandle ) == 0
      RegQueryValueEx( nHandle, "Desktop", 0, @nType, @cPath, @nLen )
      RegCloseKey( nHandle )
   endif

   cPath := AllTrim( cPath )
   IF Right( cPath, 1 ) == Chr(0)
      cPath := Left( cPath, Len( cPath ) - 1 )
   ENDIF
   IF Right( cPath, 1 ) != "\"
      cPath += "\"
   ENDIF

RETURN cPath

//-------------------------------------------------------------------------

DLL32 STATIC FUNCTION RegOpenKeyEx(nhKey     AS LONG   ,;
                                   cAddress  AS LPSTR  ,;
                                   nReserved AS LONG   ,;
                                   nSecMask  AS LONG   ,;
                                   @nphKey   AS PTR     );     //By reference
         ;
         AS LONG PASCAL FROM "RegOpenKeyExA" LIB "ADVAPI32.DLL"

//-------------------------------------------------------------------------//

DLL32 STATIC FUNCTION RegQueryValueEx(nhKey      AS LONG   ,;
                                      cAddress   AS LPSTR  ,;
                                      nReserved  AS LONG   ,;
                                      @nType     AS PTR    ,;    //By reference
                                      @cResult   AS LPSTR  ,;    //By reference
                                      @nResSize  AS PTR     );   //By reference
         ;
         AS LONG PASCAL FROM "RegQueryValueExA" LIB "ADVAPI32.DLL"

//-------------------------------------------------------------------------//
